// Solutions to the Advent Of Code 2024.
// Copyright (C) 2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/common/LogicGate.hpp>

std::istream& operator>>(std::istream& is, LogicGate& logicGate)
{
    std::string token;
    is >> logicGate.inputWire1 >> logicGate.kind >> logicGate.inputWire2 >> token >> logicGate.outputWire;
    return is;
}

std::istream& operator>>(std::istream& is, LogicGate::Kind& kind)
{
    std::string s;
    is >> s;
    switch (s[0])
    {
        case 'A' :
            kind = LogicGate::Kind::And;
            break;
        case 'O' :
            kind = LogicGate::Kind::Or;
            break;
        case 'X' :
            kind = LogicGate::Kind::Xor;
            break;
        default :
            kind = LogicGate::Kind::Unknown;
            break;
    }
    return is;
}
